/* eslint-disable no-global-assign */
/* eslint-disable no-console */
/* eslint-disable no-unused-expressions */
import React from 'react';
import { BackHandler, View, NativeModules } from 'react-native';
import Toast from 'react-native-root-toast';
import SplashScreen from 'react-native-mc-splash-screen';
import EventEmitter from '../Lib/EventEmiter';
import RouterContext from '../Lib/RouterContext';
import navigation from '../navigation';

export default screen = Target => class Enhancer extends Target {
  constructor(p) {
    super(p);
    this.name = Target.name;
    this.end = 0;
    this.begin = 0;
    this.componentDidActive = this.componentDidActive.bind(this);
    this.componentWillDeactive = this.componentWillDeactive.bind(this);
    this.backHandler = BackHandler.addEventListener('hardwareBackPress', () => this.backHardWare());
  }


  backHardWare = () => {
    if (super.backHardWare) {
      super.backHardWare();
      return true;
    }
    if (store.getState().nav.index === 0) {
      if (this.lastBackPressed && this.lastBackPressed + 2000 >= Date.now()) {
        NativeModules.NativeSupport.exitApp && NativeModules.NativeSupport.exitApp();
        return false;
      }
      Toast.show('再按一次退出!', {
        duration: 1000,
        position: Toast.positions.CENTER,
      });

      this.lastBackPressed = Date.now();
      return true;
    }
    navigation.pop();
    return true;
  }

  componentDidActive = (params) => {
    super.componentDidActive && super.componentDidActive(params);
    SplashScreen && SplashScreen.hide();
  }

  componentWillDeactive = (params) => {
    super.componentWillDeactive && super.componentWillDeactive(params);
  }

  componentWillMount() {
    super.componentWilMount && super.componentWilMount();
    this.begin = Date.now();
  }

  componentDidMount() {
    super.componentDidMount && super.componentDidMount();
    const params = (this.props.navigation.state && this.props.navigation.state.params) || {};
    if (!this.mcinited) {
      this.mcinited = true;
      super.componentDidActive && super.componentDidActive(params, false);
    }
    EventEmitter.on('MC_ROUTE_CHANDED', this.dealWithActive);
    this.end = Date.now();
    if (__DEV__) {
      console.log(`${Target.name}->组件渲染时间->${this.end - this.begin}ms`);
    }
  }

  dealWithActive = (data) => {
    const params = (this.props.navigation.state && this.props.navigation.state.params) || {};
    if (this.props.navigation.state.key === data.current.key) {
      super.componentWillDeactive && super.componentWillDeactive(params);
    } else if (this.props.navigation.state.key === data.next.key && this.mcinited) {
      super.componentDidActive && super.componentDidActive(params, true);
    }
  }

  componentWillUnmount() {
    this.setState = () => {};
    EventEmitter.removeListener('MC_ROUTE_CHANDED', this.dealWithActive);
    this.backHandler.remove();
    super.componentWillUnmount && super.componentWillUnmount();
  }

  render() {
    const ele = super.render();
    const params = (this.props.navigation.state && this.props.navigation.state.params) || {};
    return (<RouterContext.Provider
      value={{ currentKey: this.props.navigation.state.key, navigationParams: params }}
    >
      <View style={{ flex: 1, backgroundColor: '#FFF' }} >
        {ele}
      </View></RouterContext.Provider>)
    ;
  }
};
