
import EventEmitter from '../../Lib/EventEmiter';
const { NativeModules } = require('react-native');

const log = NativeModules.UMAnalyticsModule;

function getRoute(navigationState) {
  if (!navigationState) {
    return null;
  }
  const route = navigationState.routes[navigationState.index];
  if (route.routes) {
    return getRoute(route);
  }
  return route;
}

const screenTracking = ({ getState }) => next => (action) => {
  if (action.type === 'Navigation/COMPLETE_TRANSITION') {
    return next(action);
  }

  const currentRoute = getRoute(getState().nav);
  const currentKey = currentRoute.key;
  const result = next(action);
  const nextRoute = getRoute(getState().nav);
  const nextKey = nextRoute.key;
  if (currentKey !== nextKey) {
    EventEmitter.emit('MC_ROUTE_CHANDED', {
      current: currentRoute,
      next: nextRoute,
    });
  }

  if (nextRoute.routeName !== currentRoute.routeName) {
    // 象征性的用友盟对接一下
    log && log.onEventWithLabel('route', nextRoute.routeName);
  }
  return result;
};

export default screenTracking;
